#include <stdfarmos.h>

void sendCounter(void);
void recvCounter(void);
void ccaTest(void);

uint8_t buffer[RADIO_MAX_PACKET];
unsigned char state[] = {0x00, 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 
                         0x88, 0x99, 0xaa, 0xbb, 0xcc, 0xdd, 0xee, 0xff, 0xab, 0xac, 0xad};

//-------------------------------------------
//      Entry point for the application
//-------------------------------------------
void appMain(void)
{
    // ------------- setup radio
    // -- parameters
    // radioSetTxPower(30);
    // -- set packet rx callback
    radioSetReceiveHandle(recvCounter);
    // -- turn listening on
    radioOn();
    // -------------

    sendCounter(); // Uncomment this for the sending node

    for (;;) {
        mdelay(500);
        ledToggle();
    }
}

void recvCounter(void)
{
    int16_t len;
    uint8_t counter;

    len = radioRecv(buffer, sizeof(buffer));
    if (len > 0) {
        PRINTF("received ");
        for (counter = 0; counter < len; counter++) {
            PRINTF("%x ", buffer[counter]);
	}
	PRINTF("\n");
    }
}

void sendCounter(void)
{
    uint8_t counter = 0;
    for (;;) {
	PRINTF("sending ");
	for (counter = 0; counter < 19; counter++) {
            PRINTF("%x ", state[counter]);
	}
	PRINTF("\n");
	ledToggle();
	radioSend(state, 19);
        mdelay(1000);
    }
}
