/**
 * Copyright (c) 2011-2012, Institute of Electronics and Computer Science
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of  conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

//
// Simple multi-hop application
//

#include "stdfarmos.h"
#include <net/simple_mhop.h>

// Handler for packets received by base station
void handler(const void *buf, uint8_t len, addr_t sender)
{
    const uint8_t *data = buf;
    int i;

    //PRINTF("Received message from node %04X: ", sender);
    for (i = 0; i < len; i++)
        ;//PRINTF(" %02x", data[i]);
    //PRINTF("\n");
}

// Main application function
void appMain(void)
{
    // Initialize the network
    netInit();

    // Set received packet handler -- for base station
    netSetRecvHandler(handler);

    // If this is a sender node, periodically send packets; otherwise do
    // nothing
    while (1)
    {
        mdelay(7000);

#if !defined(USE_ROLE_BASE_STATION) && !defined(USE_ROLE_FORWARDER)
        static const char data[] = "Hello World!";

        netSend(data, sizeof(data));
#endif
    }
}
