/**
 * Copyright (c) 2011-2013, Institute of Electronics and Computer Science
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of  conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef FARMOS_SIMPLE_MHOP_H
#define FARMOS_SIMPLE_MHOP_H

#include <stdbool.h>

#include <defines.h>
#include <net/networking.h>

typedef MosShortAddr addr_t;

void netInit(void);

bool netSend(const void *data, uint8_t len);

typedef void (*recvHandler_t)(const void *buf, uint8_t len, addr_t sender);

void netSetRecvHandler(recvHandler_t h);

void broadcastSeed(void *);

#define DEFAULT_MEASURE_PERIOD (5L * 60) // Seconds

/* SysLog to base station */

enum {
    LOG_CRITICAL,   /* Emergency condition */
    LOG_ERROR,      /* Error */
    LOG_WARNING,    /* Warning */
    LOG_INFO,       /* Informational message */
    LOG_DEBUG,      /* Debug message */
    LOG_COUNT
};

bool syslog(uint8_t pri, const char *msg);

#endif
